import 'package:dartdoku/domains/sudoku/SudokuProblem.dart';
import 'dart:core';
import 'package:http/http.dart' as http;
import 'dart:convert';

Future<List<dynamic>> _call(Uri uri) async {
  var response = await http.get(uri);
  var json = jsonDecode(response.body);
  var boards = json['boards'];
  return boards;
}

Future<List<SudokuProblem>> getProblemsFromUri(Uri uri) async {
  var boards = await _call(uri);
  var problems = <SudokuProblem>[];
  for (var board in boards) {
    problems.add(SudokuProblem.fromJSON(board));
  }
  return problems;
}

Future<List<SudokuProblem>> getProblems(hints, count) async {
  var uri = Uri(
      scheme: 'https',
      host: 'sudoku.rusondia.net',
      port: 443,
      path: '/api/v1/hints/$hints/count/$count');
  var boards = await _call(uri);
  var problems = <SudokuProblem>[];
  for (var board in boards) {
    problems.add(SudokuProblem.fromJSON(board));
  }
  return problems;
}
